#!/usr/bin/perl -w

#
# Capture and display data from Standard Counter
#
#

# stuff we use, this wheel's been round for awhile

use strict;  # let the interpreter catch as many errors of mine as possible

# note serial port setup below needs either Device::SerialPort or Win32::Serialport perl module

# use Glib qw/TRUE FALSE/; # needed later for timer events too, like below
#add a timer to run each second
#   Glib::Timeout->add (1000,\&new_screen);



###########################################################

#globals

my $debug = 0; # set non zero to get extra debug stuff printed out on STDIO
my $running = 1; # mode control flag
my $ttyport = "ttyACM0";   # @@@ edit if Multi-Geiger on a different tty port 
my $port; # serial port pointer
my $opsys; # true if linux, false if windows
my $portname; # full name of port




###########################################################
# setup serial port and return false if error
sub setupserial()
{
# first find out what the opsys is
 if ($^O =~ m/linux/i) # special variable tells us opsys
 {
  require Device::SerialPort; # the correct one for linux
  $opsys = 1;  # true for linux
  print ("\nUsing Linux serial driver\n");
 } 
 elsif ($^O =~ m/MSWin32/i)
 {
  require Win32::SerialPort; # the one for windoze
  $opsys = 0; # a big zero for win32
  print ("\nUsing Windows serial driver\n");
 }
 else
 {
  die "Unknown opsys: $^O"; # can't do much without a serial driver
 }

# now, init serial port from code defaults or config file
# @@@ this is the linux code, windows will be different?


    my $cfgfile = sprintf("%s.cfg", $ttyport);
    if($opsys) { $portname = sprintf("/dev/%s", $ttyport); }
    else {$portname = $ttyport;}  # windows case, com? or something	 

    if ( -e $cfgfile ) {   # cfgfile exists
      $port = Device::SerialPort->start ($cfgfile) or die "Can't start $cfgfile\n";
	} else {   # cfgfile does not exist (e.g. 1st time for a tty device)
      $port = new Device::SerialPort ($portname, 1) || die "Can't open $portname: $!\n";
	}

    # some of this not needed if config file exists, this is for suspenders (and first times)
      $port->databits(8);
      $port->baudrate(57600);
      $port->parity("none");
      $port->stopbits(1);
      $port->handshake("none");
      $port->stty_icanon(1);    # this is what gets us on line boundaries
      $port->are_match("\n");                       # possible end strings
      $port->lookclear;                             # empty the buffer
      $port->write_settings || undef $port; # die, sort of, if not working
      $port->save($cfgfile) || warn "Can't save $cfgfile: $!\n"; # save for next time

}
#############################################



#///////////////// Main program

print ("\nStandard Counter Data aquisition\n");
print ("\nRunning on Opsys: $^O \n"); # cute
 
setupserial(); # try to get the serial port for the Standard Counter, or report errors

 while ($running) # loop forever looking for input to work with
 { # run till ctl-c
 


 }




